%
% function sfilter = build_sfilter(x);
%
% Returns, "sfilter", the 4 filter of the regularizinger of our BID
% method, with the size of x.
%
% Mariana S. C. Almeida; 2012
% Instituto de Telecomunicaes, Lisbon, Portugal 
% marianascalmeida@.gmail.com

function sfilter = build_sfilter(x);

[sz1 sz2] = size(x);

v1=[1 2 2 1];
v1=v1/sum(v1)/2;

filter_base = [ v1  ; -v1 ]; 
filter_base = padarray( filter_base , [7 6] , 0 );

sfilter1(:,:,1) =  filter_base;
sfilter1(:,:,2) =  imrotate( filter_base , 45 , 'bicubic','crop'); 
sfilter1(:,:,3) =  imrotate( filter_base , 90 , 'bicubic','crop'); 
sfilter1(:,:,4) =  imrotate( filter_base , 135 , 'bicubic','crop'); 


sfilter(:,:,1) =  ( ht2h( squeeze(sfilter1(:,:,1)) , sz1 , sz2 ) );
sfilter(:,:,2) =  ( ht2h( squeeze(sfilter1(:,:,2)) , sz1 , sz2 ) );
sfilter(:,:,3) =  ( ht2h( squeeze(sfilter1(:,:,3)) , sz1 , sz2 ) );
sfilter(:,:,4) =  ( ht2h( squeeze(sfilter1(:,:,4)) , sz1 , sz2 ) );

