%
%   x = generalized_shrinkage( y , lambda ,q )
%
% vectorial shrinkage with a generic sparsity parameters "q".
%
% Mariana S. C. Almeida; 2013
% Instituto de Telecomunicaes, Lisbon, Portugal 
% marianascalmeida@.gmail.com
%

function x_min = generalized_shrinkage( y , lambda , q )

try q;  
catch me, q=1; % default: soft-thresholding
end

[n N] = size( y );
y = reshape(y, n,[] );


y2 = ones(1,N);

norm_y = sqrt( sum(y.^2) );
if numel(lambda)>1
lambda2 = ( reshape(lambda,1,[]) ).*(norm_y.^(q-2));
else
lambda2 = lambda.*(norm_y.^(q-2));
end

%c = shrinkage( y2 , lambda2 ,q, 0);
c = shrinkage_CaoXu2013( y2 , lambda2 ,q);

x_min = repmat(c, n,1).*y;

