% function  [ht] = motion_filter(comp, ang)
%
% Returns a filter "ht", with a length "comp" and an angle "ang"
%
%
% Mariana S. C. Almeida
% Instituto de Telecomunicaes, Lisbon, Portugal 
% marianascalmeida@gmail.com

function  [ht] = motion_filter(length, ang)

    
if rem(ceil(length),2) length2 = ceil(length); else length2 = ceil(length)+1; end

ht = zeros(length2);

if length <= 1
    linha=1;
    ht(ceil(length2/2),:)=linha;
else
    naux = ceil(length/2)-1;
    linha1 = repmat(1,1,naux);
    linha2 = (length-1-(2*naux))/2;
    if linha2>0
        linha = [linha2 linha1 1 linha1 linha2];
    else
        linha = [linha1 1 linha1];
        linha(1)=linha(1)+linha2;
        linha(end)=linha(end)+linha2;
    end
    ht(ceil(length2/2),:)=linha;
end

ht = imrotate(ht, ang,'bicubic','crop');
ht=ht/sum(sum(ht));

